unit mainfrm;

{===========================================================
 Please note, that the program MOLFORM uses the unit NumLab,
 which is not supplied with the CFORM component. If you don't
 have them, you can download them from the following WWW
 site:  http://www.lohninger.com/
 ===========================================================}


{-----------------------------------------------------------------}
interface
{-----------------------------------------------------------------}

uses
  WinTypes, Winprocs, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, cform, StdCtrls, ExtCtrls, Buttons, NumLab;

type
  TFrmMolF = class(TForm)
    MolForm1: TMolForm;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    BitBtn1: TBitBtn;
    EdFormul1: TEdit;
    Label1: TLabel;
    MolForm2: TMolForm;
    Label2: TLabel;
    EdFormul2: TEdit;
    BButCompare: TBitBtn;
    LblCompareRslt: TLabel;
    MolForm3: TMolForm;
    BButFind: TBitBtn;
    CBTransparent: TCheckBox;
    SBMass: TScrollBar;
    NLabMass: TNumLab;
    NLabTol: TNumLab;
    SBTol: TScrollBar;
    Bevel1: TBevel;
    CBoxPlausib: TCheckBox;
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure EdFormul1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EdFormul2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BButCompareClick(Sender: TObject);
    procedure BButFindClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CBTransparentClick(Sender: TObject);
    procedure SBTolChange(Sender: TObject);
    procedure SBMassChange(Sender: TObject);
    procedure CBoxPlausibClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMolF: TFrmMolF;
  IniDone  : boolean;

{-----------------------------------------------------------------}
implementation
{-----------------------------------------------------------------}


{$R *.DFM}

(*****************************************************************)
procedure TFrmMolF.RadioButton1Click(Sender: TObject);
(*****************************************************************)

begin
MolForm1.NumAtoms := 2;
MolForm1.AtNum[1] := 6;
MolForm1.AtWgt[1] := 12;
MolForm1.AtCnt[1] := 8;
MolForm1.AtNum[2] := 1;
MolForm1.AtWgt[2] := 1;
MolForm1.AtCnt[2] := 18;
MolForm1.Showit;
end;

(*****************************************************************)
procedure TFrmMolF.RadioButton2Click(Sender: TObject);
(*****************************************************************)

begin
MolForm1.NumAtoms := 3;
MolForm1.AtNum[1] := 6;
MolForm1.AtWgt[1] := 12;
MolForm1.AtCnt[1] := 8;
MolForm1.AtNum[2] := 1;
MolForm1.AtWgt[2] := 1;
MolForm1.AtCnt[2] := 16;
MolForm1.AtNum[3] := 8;
MolForm1.AtWgt[3] := 17;
MolForm1.AtCnt[3] := 1;
MolForm1.Showit;
end;

(*****************************************************************)
procedure TFrmMolF.RadioButton3Click(Sender: TObject);
(*****************************************************************)

begin
MolForm1.NumAtoms := 2;
MolForm1.AtNum[1] := 1;
MolForm1.AtWgt[1] := 2;
MolForm1.AtCnt[1] := 2;
MolForm1.AtNum[2] := 8;
MolForm1.AtWgt[2] := 16;
MolForm1.AtCnt[2] := 1;
MolForm1.Showit;
end;

(*****************************************************************)
procedure TFrmMolF.RadioButton4Click(Sender: TObject);
(*****************************************************************)

begin
MolForm1.NumAtoms := 4;
MolForm1.AtNum[1] := 6;
MolForm1.AtWgt[1] := 12;
MolForm1.AtCnt[1] := 2;
MolForm1.AtNum[2] := 1;
MolForm1.AtWgt[2] := 1;
MolForm1.AtCnt[2] := 5;
MolForm1.AtNum[3] := 8;
MolForm1.AtWgt[3] := 16;
MolForm1.AtCnt[3] := 1;
MolForm1.AtNum[4] := 1;
MolForm1.AtWgt[4] := 1;
MolForm1.AtCnt[4] := 1;
MolForm1.Showit;
end;

(*****************************************************************)
procedure TFrmMolF.BitBtn1Click(Sender: TObject);
(*****************************************************************)

begin
close;
end;

(*****************************************************************)
procedure TFrmMolF.EdFormul1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
(*****************************************************************)

begin
MolForm1.ReadFromString(EdFormul1.Text);
end;

(*****************************************************************)
procedure TFrmMolF.EdFormul2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
(*****************************************************************)

begin
MolForm2.ReadFromString(EdFormul2.Text);
end;

(*****************************************************************)
procedure TFrmMolF.BButCompareClick(Sender: TObject);
(*****************************************************************)

var
  crslt  : integer;
  astr   : string;

begin
crslt := MolForm1.CompareTo (MolForm2);
case crslt of
   2 : astr := 'left is contained in right formula';
   1 : astr := 'right formula is contained in left';
   0 : astr := 'right formula equals left';
  -1 : astr := 'right and left formula are neither equal nor contained';
  -2 : astr := 'at least one of the formulas is empty';
end;
LblCompareRslt.Caption := astr;
end;


(*****************************************************************)
procedure TFrmMolF.BButFindClick(Sender: TObject);
(*****************************************************************)

var
  LowF, HighF : TFormulaRec;

begin
if not IniDone then
  begin
  MolForm3.ShowAsText := false;
  LowF.FLeng := 4;              { lower formula: C0 H0 O0 Cl0 }
  LowF.AtNum[1] := 6;
  LowF.AtWgt[1] := 12;
  LowF.AtCnt[1] := 0;
  LowF.AtNum[2] := 1;
  LowF.AtWgt[2] := 1;
  LowF.AtCnt[2] := 0;
  LowF.AtNum[3] := 8;
  LowF.AtWgt[3] := 16;
  LowF.AtCnt[3] := 0;
  LowF.AtNum[4] := 17;
  LowF.AtWgt[4] := 35;
  LowF.AtCnt[4] := 0;
  HighF.FLeng := 4;             { upper formula: C16 H34 O4 Cl3 }
  HighF.AtNum[1] := 6;
  HighF.AtWgt[1] := 12;
  HighF.AtCnt[1] := 16;
  HighF.AtNum[2] := 1;
  HighF.AtWgt[2] := 1;
  HighF.AtCnt[2] := 34;
  HighF.AtNum[3] := 8;
  HighF.AtWgt[3] := 16;
  HighF.AtCnt[3] := 4;
  HighF.AtNum[4] := 17;
  HighF.AtWgt[4] := 35;
  HighF.AtCnt[4] := 3;
  if MolForm3.InitFindFormula (NLabMass.Value, NLabTol.Value, LowF, HighF) then
    IniDone := true;
  end;
if not MolForm3.FindFormulaExactMass (CBoxPlausib.Checked) then
  begin
  MolForm3.ShowAsText := true;
  MolForm3.MolFormula := 'no more formulas';
  IniDone :=false;
  end;
end;

(*****************************************************************)
procedure TFrmMolF.FormCreate(Sender: TObject);
(*****************************************************************)

begin
IniDone := false;
end;

(*****************************************************************)
procedure TFrmMolF.CBTransparentClick(Sender: TObject);
(*****************************************************************)

begin
MolForm1.Transparent := CBTransparent.Checked;
MolForm2.Transparent := CBTransparent.Checked;
end;

(*****************************************************************)
procedure TFrmMolF.SBTolChange(Sender: TObject);
(*****************************************************************)

begin
NLabTol.Value := SBTol.Position/1000;
IniDOne := false;
MolForm3.Clear;
end;

(*****************************************************************)
procedure TFrmMolF.SBMassChange(Sender: TObject);
(*****************************************************************)

begin
NLabMass.Value := SBMass.Position/100;
IniDOne := false;
MolForm3.Clear;
end;

(*****************************************************************)
procedure TFrmMolF.CBoxPlausibClick(Sender: TObject);
(*****************************************************************)

begin
IniDone := false;
MolForm3.Clear;
end;

end.
