unit Maingf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, GradFl, StdCtrls, Buttons, ExtCtrls, Colsel, NumIO;

type
  TFrmGrafFill = class(TForm)
    BButExit: TBitBtn;
    Label1: TLabel;
    GradFill3: TGradFill;
    GFQuad: TGradFill;
    Label3: TLabel;
    ColSel1: TColSel;
    ColSel2: TColSel;
    SBToggleColors: TSpeedButton;
    RGSelect: TRadioGroup;
    RBRadial: TRadioButton;
    RBVertical: TRadioButton;
    RBMidBandVert: TRadioButton;
    RBMidBandHoriz: TRadioButton;
    RBHoriz: TRadioButton;
    RBEllipticFull: TRadioButton;
    RBEllipticFit: TRadioButton;
    RBDiagGrid: TRadioButton;
    NIONumColors: TNumIO;
    Label2: TLabel;
    procedure BButExitClick(Sender: TObject);
    procedure SBToggleColorsClick(Sender: TObject);
    procedure ColSel1Change(Sender: TObject);
    procedure ColSel2Change(Sender: TObject);
    procedure RBRadialClick(Sender: TObject);
    procedure RBVerticalClick(Sender: TObject);
    procedure RBMidBandVertClick(Sender: TObject);
    procedure RBMidBandHorizClick(Sender: TObject);
    procedure RBHorizClick(Sender: TObject);
    procedure RBEllipticFullClick(Sender: TObject);
    procedure RBEllipticFitClick(Sender: TObject);
    procedure RBDiagGridClick(Sender: TObject);
    procedure NIONumColorsChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmGrafFill: TFrmGrafFill;

implementation


{$R *.DFM}

(***************************************************************)
procedure TFrmGrafFill.BButExitClick(Sender: TObject);
(***************************************************************)

begin
close;
end;


(***************************************************************)
procedure TFrmGrafFill.SBToggleColorsClick(Sender: TObject);
(***************************************************************)

var
  ColorDummy : TColor;

begin
GFQuad.ColorFlipped := not GFQuad.ColorFlipped;
ColorDummy := ColSel1.SelColor;
ColSel1.SelColor := ColSel2.SelColor;
ColSel2.SelColor := ColorDummy;
end;

(***************************************************************)
procedure TFrmGrafFill.ColSel1Change(Sender: TObject);
(***************************************************************)

begin
GFQuad.ColorFirst := ColSel1.SelColor;
end;

(***************************************************************)
procedure TFrmGrafFill.ColSel2Change(Sender: TObject);
(***************************************************************)

begin
GFQuad.ColorLast := ColSel2.SelColor;
end;

(***************************************************************)
procedure TFrmGrafFill.RBRadialClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtRadial;
end;

(***************************************************************)
procedure TFrmGrafFill.RBVerticalClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtVert;
end;

(***************************************************************)
procedure TFrmGrafFill.RBMidBandVertClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtMidBandVert;
end;

(***************************************************************)
procedure TFrmGrafFill.RBMidBandHorizClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtMidBandHoriz;
end;

(***************************************************************)
procedure TFrmGrafFill.RBHorizClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtHoriz;
end;

(***************************************************************)
procedure TFrmGrafFill.RBEllipticFullClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtEllipticFull;
end;

(***************************************************************)
procedure TFrmGrafFill.RBEllipticFitClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtEllipticFit;
end;

(***************************************************************)
procedure TFrmGrafFill.RBDiagGridClick(Sender: TObject);
(***************************************************************)

begin
GFQuad.FillType := gtDiagGrid;
end;

(***************************************************************)
procedure TFrmGrafFill.NIONumColorsChange(Sender: TObject);
(***************************************************************)

begin
GFQuad.NrColors := round(NIONumColors.Value);
end;

end.
