unit Neditfrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, Grids, NTabEd, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    NTabEd1: TNTabEd;
    SBExit: TSpeedButton;
    SBInput: TSpeedButton;
    SBImport: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SBRandFill: TSpeedButton;
    SBColAtt: TSpeedButton;
    SBRowAtt: TSpeedButton;
    SBExport: TSpeedButton;
    SaveDialog1: TSaveDialog;
    SBAutoSize: TSpeedButton;
    procedure SBExitClick(Sender: TObject);
    procedure SBInputClick(Sender: TObject);
    procedure SBImportClick(Sender: TObject);
    procedure SBRandFillClick(Sender: TObject);
    procedure SBColAttClick(Sender: TObject);
    procedure SBRowAttClick(Sender: TObject);
    procedure NTabEd1ChangeSetup(Sender: TObject);
    procedure SBExportClick(Sender: TObject);
    procedure SBAutoSizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


(*******************************************************************)
procedure TForm1.SBExitClick(Sender: TObject);
(*******************************************************************)

begin
close;
end;

(*******************************************************************)
procedure TForm1.SBInputClick(Sender: TObject);
(*******************************************************************)

begin
if SBInput.Down
  then begin
       NTabEd1.Options := NTabEd1.Options + [goEditing];
       SBImport.Enabled := false;
       end
  else begin
       NTabEd1.Options := NTabEd1.Options - [goEditing];
       SBImport.Enabled := true;
       end;
end;

(*******************************************************************)
procedure TForm1.SBImportClick(Sender: TObject);
(*******************************************************************)

var
  error : integer;

begin
OpenDialog1.Filter := 'ASC-Files|*.ASC';
if OpenDialog1.Execute then
  error := NTabEd1.ImportASCFile (OpenDialog1.Filename, true);
end;


(*******************************************************************)
procedure TForm1.SBRandFillClick(Sender: TObject);
(*******************************************************************)

var
  i, j : longint;

begin
NTabEd1.SuppressPaint := true;
for i:=1 to NTabEd1.NrOfColumns do
  for j:=1 to NTabEd1.NrOfRows do
    NTabEd1.Elem[i,j] := random;
NTabEd1.SuppressPaint := false;
end;

(*******************************************************************)
procedure TForm1.SBColAttClick(Sender: TObject);
(*******************************************************************)

begin
NTabed1.AttribColVisible := not NTabed1.AttribColVisible;
end;

(*******************************************************************)
procedure TForm1.SBRowAttClick(Sender: TObject);
(*******************************************************************)

begin
NTabed1.AttribRowVisible := not NTabed1.AttribRowVisible;
end;

(*******************************************************************)
procedure TForm1.NTabEd1ChangeSetup(Sender: TObject);
(*******************************************************************)

begin
if goEditing in NTabed1.Options
  then SBInput.Down := true
  else SBInput.Down := false;
end;

(*******************************************************************)
procedure TForm1.SBExportClick(Sender: TObject);
(*******************************************************************)

begin
SaveDialog1.Filter := 'ASC-Files|*.ASC';
if SaveDialog1.Execute then
  NTabEd1.ExportASCFile (SaveDialog1.Filename, 4);
end;


(*******************************************************************)
procedure TForm1.SBAutoSizeClick(Sender: TObject);
(*******************************************************************)

var
  i: integer;

begin
for i:=-1 to NTabed1.NrOfColumns do
  NTabed1.AutoColWidth (i,true,4);
end;

end.
