unit frmnumin;

{===========================================================
 Please note, that the program NUMIN uses the unit NumLab,
 which is not supplied with the NUMIO package. If you don't
 have it, you can download a shareware copy from the following
 web site:  http://www.lohninger.com/
 ===========================================================}

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, NumIO, NumLab, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    NumIO1: TNumIO;
    NumLab1: TNumLab;
    Label1: TLabel;
    BButExit: TBitBtn;
    GroupBox1: TGroupBox;
    CBFormat: TComboBox;
    NumIO2: TNumIO;
    NumIO3: TNumIO;
    Label4: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    CBBeep: TCheckBox;
    procedure NumIO1Change(Sender: TObject);
    procedure CBFormatChange(Sender: TObject);
    procedure BButExitClick(Sender: TObject);
    procedure NumIO2Change(Sender: TObject);
    procedure NumIO3Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CBBeepClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(************************************************************************)
procedure TForm1.NumIO1Change(Sender: TObject);
(************************************************************************)

begin
NumLab1.ColorLabBakg := clSilver;
NumLab1.Value := NumIO1.Value;
end;

(************************************************************************)
procedure TForm1.CBFormatChange(Sender: TObject);
(************************************************************************)

begin
case CBFormat.ItemIndex of
  0: NumIO1.InputFormat:=itDynamic;
  1: NumIO1.InputFormat:=itInt;
  2: NumIO1.InputFormat:=itFloat;
  3: NumIO1.InputFormat:=itExp;
  4: NumIO1.InputFormat:=itBin;
  5: NumIO1.InputFormat:=itOct;
  6: NumIO1.InputFormat:=itHex;
end;
end;

(************************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(************************************************************************)

begin
close;
end;

(************************************************************************)
procedure TForm1.NumIO2Change(Sender: TObject);
(************************************************************************)

begin
NumIO1.RangeHigh := NumIO2.Value;
end;

(************************************************************************)
procedure TForm1.NumIO3Change(Sender: TObject);
(************************************************************************)

begin
NumIO1.RangeLow := NumIO3.Value;
end;

(************************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(************************************************************************)

begin
CBFormat.Itemindex := 3;
NumIO2.Value := NumIO1.RangeHigh;
NumIO3.Value := NumIO1.RangeLow;
end;

(************************************************************************)
procedure TForm1.CBBeepClick(Sender: TObject);
(************************************************************************)

begin
NumIO1.Beep := CBBeep.Checked;
end;

end.
