unit ureplist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, replist, Colsel;

type
  TForm1 = class(TForm)
    RL1: TReportListView;
    BButAddRow: TBitBtn;
    BButUnsort: TBitBtn;
    CSText: TColSel;
    CSBkg1: TColSel;
    CSBkg2: TColSel;
    SBarRowPat: TScrollBar;
    BButExit: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ColorDialog1: TColorDialog;
    CBVertLines: TCheckBox;
    CBHorzLines: TCheckBox;
    SBEdit: TSpeedButton;
    ButStore: TButton;
    BButLoadXML: TButton;
    OpenDialog1: TOpenDialog;
    SBCheckedCol1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    procedure BButAddRowClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BButUnsortClick(Sender: TObject);
    procedure CSTextChange(Sender: TObject);
    procedure CSBkg1Change(Sender: TObject);
    procedure CSBkg2Change(Sender: TObject);
    procedure SBarRowPatChange(Sender: TObject);
    procedure BButExitClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure CBVertLinesClick(Sender: TObject);
    procedure CBHorzLinesClick(Sender: TObject);
    procedure SBEditClick(Sender: TObject);
    procedure ButStoreClick(Sender: TObject);
    procedure BButLoadXMLClick(Sender: TObject);
    procedure SBCheckedCol1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  FirstNames : array[1..20] of string[10] =
                  ('John','Jack','Jill','Pat','Morgan',
                   'Robert','Hugh','Thomas','Alex','Dave',
                   'Jeffrey','Mark','Buddy','Vince','Cliff',
                   'Claudia','Sally','Elizabeth','Gail','Michael');
  LastNames : array[1..20] of string[12] =
                  ('Hayek','Braaten','Lohninger','Arsenna','Mortensen',
                   'Miller','Stewart','Collaud','Bergh','Wiles',
                   'Bock','Stefferson','Nilsson','Johansson','Horvath',
                   'Christiansen','Maltese','Wilson','Churchill','Clinton');
  Addresses : array[1..20] of string[40] =
                  ('Bollene, France','Vienna, Austria','Amsterdam, The Netherlands','Austin, Texas','Milton, Australia',
                   'Ikast, Denmark','Heidenheim, Germany','Richmond, California','Vail, Colorado','Cape Town, RSA',
                   'Berlin, Germany','Rio, Brazil','Takasaki, Japan','Stockholm, Sweden','Budapest, Hungary',
                   'Barcelona, Spain','Taipei, Taiwan','New Orleans, USA','Moscow, Russia','Auckland, New Zealand');


(**************************************************************)
procedure TForm1.BButAddRowClick(Sender: TObject);
(**************************************************************)

var
  i, ix : integer;

begin
RL1.SuppressPaint := true;
for i:=1 to 100 do
  begin
  ix := RL1.AddRow;
  RL1[1,ix] := IntToStr(ix);
  RL1[2,ix] := FirstNames[1+random(20)];
  RL1[3,ix] := LastNames[1+random(20)];
  RL1[4,ix] := Addresses[1+random(20)];
  end;
RL1.SuppressPaint := false;
end;

(**************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(**************************************************************)

var
  i: integer;

begin
RL1.SuppressPaint := true;
RL1.Header[1] := 'Cust.No.';
RL1.Header[2] := 'First Name';
RL1.Header[3] := 'Last Name';
RL1.Header[4] := 'Address';
for i:=1 to RL1.NrOfRows do
  begin
  RL1[1,i] := IntToStr(i);
  RL1[2,i] := FirstNames[1+random(20)];
  RL1[3,i] := LastNames[1+random(20)];
  RL1[4,i] := Addresses[1+random(20)];
  end;
RL1.SuppressPaint := false;
CSText.Selcolor := RL1.ColorText;
CSBkg1.SelColor := RL1.ColorBkgdNormal;
CSBkg2.SelColor := RL1.ColorBkgdShaded;
end;

(**************************************************************)
procedure TForm1.BButUnsortClick(Sender: TObject);
(**************************************************************)

begin
RL1.Unsort;
end;

(**************************************************************)
procedure TForm1.CSTextChange(Sender: TObject);
(**************************************************************)

begin
RL1.ColorText := CSText.SelColor;
end;

(**************************************************************)
procedure TForm1.CSBkg1Change(Sender: TObject);
(**************************************************************)

begin
RL1.ColorBkgdNormal := CSBkg1.SelColor;
end;

(**************************************************************)
procedure TForm1.CSBkg2Change(Sender: TObject);
(**************************************************************)

begin
RL1.ColorBkgdShaded := CSBkg2.SelColor;
end;

(**************************************************************)
procedure TForm1.SBarRowPatChange(Sender: TObject);
(**************************************************************)

begin
RL1.RowColPattern := SBarRowPat.Position;
end;

(**************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(**************************************************************)

begin
close;
end;

(**************************************************************)
procedure TForm1.SpeedButton1Click(Sender: TObject);
(**************************************************************)

begin
if ColorDialog1.Execute then
  begin
  CSBkg1.SelColor := ColorDialog1.Color;
  RL1.ColorBkgdNormal := ColorDialog1.Color;
  end;
end;

(**************************************************************)
procedure TForm1.SpeedButton2Click(Sender: TObject);
(**************************************************************)

begin
if ColorDialog1.Execute then
  begin
  CSBkg2.SelColor := ColorDialog1.Color;
  RL1.ColorBkgdShaded := ColorDialog1.Color;
  end;
end;



(**************************************************************)
procedure TForm1.CBVertLinesClick(Sender: TObject);
(**************************************************************)

begin
if CBVertLines.Checked
  then RL1.Options := RL1.Options + [goVertLine]
  else RL1.Options := RL1.Options - [goVertLine];
end;

(**************************************************************)
procedure TForm1.CBHorzLinesClick(Sender: TObject);
(**************************************************************)

begin
if CBHorzLines.Checked
  then RL1.Options := RL1.Options + [goHorzLine]
  else RL1.Options := RL1.Options - [goHorzLine];
end;


(**************************************************************)
procedure TForm1.SBEditClick(Sender: TObject);
(**************************************************************)

var
  i : integer;

begin
If SBEdit.Down
  then begin
       SBEdit.Caption := 'Edit On';
       RL1.Options := RL1.Options + [goEditing] - [goRowSelect];
       for i:=1 to RL1.NrOfColumns do
         RL1.ColumnEditable[i] := true;
       end
  else begin
       SBEdit.Caption := 'Edit Off';
       RL1.Options := RL1.Options - [goEditing] + [goRowSelect];
       for i:=1 to RL1.NrOfColumns do
         RL1.ColumnEditable[i] := false;
       end;
end;

(**************************************************************)
procedure TForm1.ButStoreClick(Sender: TObject);
(**************************************************************)

begin
if SaveDialog1.Execute then
  begin
  RL1.SaveAsXMLFile (SaveDialog1.Filename, 'TestRepList');
  end;
end;

(**************************************************************)
procedure TForm1.BButLoadXMLClick(Sender: TObject);
(**************************************************************)

begin
if OpenDialog1.Execute then
  begin
  if not RL1.LoadFromXMLFile (OpenDialog1.Filename, '')
    then MessageDlg ('could not read report list from selected file', mtError, [mbOK], 0);
  SBCheckedCol1.Down := RL1.IsCheckedColumn[1];
  end;
end;

(**************************************************************)
procedure TForm1.SBCheckedCol1Click(Sender: TObject);
(**************************************************************)

begin
RL1.IsCheckedColumn[1] := SBCheckedCol1.Down;
end;

end.                                           '
