unit ugrep;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  stringl, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MMResult: TMemo;
    Panel1: TPanel;
    BButExit: TBitBtn;
    Label1: TLabel;
    EdRegexp: TEdit;
    CBIgnoreCase: TCheckBox;
    BButStartSearch: TBitBtn;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CBIgnoreCaseClick(Sender: TObject);
    procedure BButExitClick(Sender: TObject);
  private
    SearchStr: TGrep;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(*************************************************************)
procedure TForm1.Button1Click(Sender: TObject);
(*************************************************************)

var
  Infile : TextFile;
  astr   : string;
  bstr   : string;
  ix     : integer;
  linecnt: longint;

begin
SearchStr.RegExp := EdRegExp.Text;
MMResult.Clear;
OpenDialog1.Filename := '*.txt';
if OpenDialog1.Execute then
  begin
  assignFile (InFile, OpenDialog1.Filename);
  reset (Infile);
  linecnt := 0;
  MMResult.Visible := false;
  while not eof(InFile) do
    begin
    readln (Infile, astr);
    inc(linecnt);
    if SearchStr.MatchString (astr, ix) then
      begin
      str (linecnt:4,bstr);
      bstr := bstr + ' ['+inttostr(SearchSTr.MatchStartPos)+'-'+inttostr(SearchStr.MatchEndPos)+']';
      MMResult.Lines.Add (LeftString(bstr,12)+': '+astr);
      end;
    end;
  MMResult.Visible := true;
  closeFile (Infile);
  end;
end;

(*************************************************************)
procedure TForm1.FormCreate(Sender: TObject);
(*************************************************************)

begin
SearchStr := TGrep.Create;
end;

(*************************************************************)
procedure TForm1.CBIgnoreCaseClick(Sender: TObject);
(*************************************************************)

begin
if CBIgnoreCase.Checked
  then SearchStr.IgnoreCase := true
  else SearchStr.IgnoreCase := false;
end;

(*************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(*************************************************************)

begin
close;
end;

end.
